

#include "AVBcom.h"

/******************************************************************
**  Acad::ErrorStatus ColorLine()
**  
**	   
**
**  **avb
**
****************************/
Acad::ErrorStatus ColorLine()
{
ads_point pt1, pt2;
	int retval,color;
	
color=set_ColorIndex("\n  / <ENTER>- :");
if (color==500)
return Acad::eUserBreak;
//else if (color=300)

	try
	{
		if ((retval = acedGetPoint(NULL, "\n  :", pt1)) != RTNORM)
			throw retval;
	}
		catch (int e)
	{
		if (e == RTCAN || e == RTNONE )
			return Acad::eUserBreak;
		if (e == RTERROR)
			return Acad::eInvalidInput;
	}
while (1 == 1) {

		try
	{
		if ((retval = acedGetPoint(pt1, "\n  :", pt2)) != RTNORM)
			throw retval;
	}
		catch (int e)
	{
		if (e == RTCAN || e == RTNONE)
			return Acad::eUserBreak;
		if (e == RTERROR)
			return Acad::eInvalidInput;
	}
	AcDbLine* pLine = new AcDbLine(asPnt3d(pt1), asPnt3d(pt2));
	if (!pLine)
	{
		acedAlert("  ,   !");
		return Acad::eOutOfMemory;
	}
		
			pLine->setColorIndex(color);
pt1[0]=pt2[0];
pt1[1]=pt2[1];
pt1[2]=pt2[2];
AcDbObjectId id;
postToDatabase(pLine, id);
}
}

/******************************************************************
**  Acad::ErrorStatus createLpLine()
**  
**	   
**
**  **avb
**
****************************/
Acad::ErrorStatus
createLpLine()
{

	ads_point   sp, ep, mp, p1;
	int retval;
	try
	{
		if ((retval = acedGetPoint(NULL, "\n  :  ", sp)) != RTNORM)
			throw retval;
	}
	 catch (int e)
	{
		if (e == RTCAN || e == RTNONE)
			return Acad::eUserBreak;
		if (e == RTERROR)
			return Acad::eInvalidInput;
	}
while (1)
{
		try
	{
		if ((retval = acedGetPoint(sp, "\n  :  ", ep)) != RTNORM)
			throw retval;
		if ((sp[X] != ep[X]) && (sp[Y] != ep[Y]))
		{
		if ((retval = acedGetPoint(NULL, "\n  :  ", mp)) != RTNORM)
			throw retval;
		}
	}
	 catch (int e)
	{
		if (e == RTCAN || e == RTNONE)
			return Acad::eUserBreak;
		if (e == RTERROR)
			return Acad::eInvalidInput;
	}

#define X 0 
#define Y 1 
#define Z 2 


double x2= ep[X]-sp[X];
double x3= mp[X]-sp[X];
double y2= ep[Y]-sp[Y];
double y3= mp[Y]-sp[Y];
double d2 = fabs(100*y2/x2);
double d3 = fabs(100*y3/x3);
//acutPrintf(" d3== %f\n",  d3);
if (sp[X] < ep[X] && sp[Y] < ep[Y])
{
	if ((y3>0 && x3>0 && d2>d3) || (y3<0 && x3>0) || (y3<0 && x3<0 && d2<d3))
	{
		p1[X] = ep[X];
		p1[Y] = sp[Y];
	}
	else
	{	
		p1[X] = sp[X];
		p1[Y] = ep[Y];
	}
}
else if (sp[X] > ep[X] && sp[Y] > ep[Y])
{
	if ((y3>0 && x3>0 && d2>d3) || (y3<0 && x3>0) || (y3<0 && x3<0 && d2<d3))
	{	
		p1[X] = sp[X];
		p1[Y] = ep[Y];
	}	
	else
	{
		p1[X] = ep[X];
		p1[Y] = sp[Y];
	}
}
else if (sp[X] > ep[X] && sp[Y] < ep[Y])
{
	if ((y3>0 && x3<0 && d2<d3) || (y3>0 && x3>0) || (y3<0 && x3>0 && d2>d3))
	{	
		p1[X] = sp[X];
		p1[Y] = ep[Y];
	}	
	else
	{
		p1[X] = ep[X];
		p1[Y] = sp[Y];
	}
}
else if (sp[X] < ep[X] && sp[Y] > ep[Y])
{
	if ((y3>0 && x3<0 && d2<d3) || (y3>0 && x3>0) || (y3<0 && x3>0 && d2>d3))
	{
		p1[X] = ep[X];
		p1[Y] = sp[Y];
	}
	else
	{	
		p1[X] = sp[X];
		p1[Y] = ep[Y];
	}
}
if (sp[X] == ep[X] || sp[Y] == ep[Y])
{
	newLine(sp,ep);
}
else
{
newLine(sp,p1);
newLine(p1,ep);
}
sp[X]=ep[X];
sp[Y]=ep[Y];
sp[Z]=ep[Z];

}
return Acad::eOk;
}
/******************************************************************
**  AcDbObjectId changeColorEntity()
**  
**	     
**
**  **avb
**
****************************/
AcDbObjectId
changeColorEntity()
{
	AcDbObjectId eId;
	int color=900;
	color=set_ColorIndex("\n  / <ENTER>-");
	if (color==500)
		return NULL;
	else if(color==300){
		const char *ch;
		ch=getChSysVar("CECOLOR");
		//acutPrintf(ch);
		color=atoi(ch);
		//acutPrintf("%i",color);
	}
while (1)
{
	    ads_name sset;
    if (acedSSGet(NULL, NULL, NULL, NULL, sset) != RTNORM) {
        acutPrintf("\n  ");
        return eId;
    }
    long length;
    acedSSLength(sset, &length);
    AcDbObjectIdArray  objList;
    AcDbObjectId ownerId = AcDbObjectId::kNull;
    for (int i = 0; i < length; i++) {
        ads_name ent;
        acedSSName(sset, i, ent);
        AcDbObjectId objId;
        acdbGetObjectId(objId, ent);
		changeColor(objId, color);
	}
acedSSFree(sset);

}
return eId;
}

/******************************************************************
**  Acad::ErrorStatus join()
**  
**	  
**
**  **avb
**
****************************/
Acad::ErrorStatus join()
{
AcGePoint3d nsp, nep;
AcGePoint3d sp1;
AcGePoint3d sp2;
AcGePoint3d ep1;
AcGePoint3d ep2;
ads_point pn1;
ads_point pn2;
ads_name en1;
ads_name en2;
AcDbObjectId eId1, eId2 ;
AcDbEntity* pEnt1=NULL;
AcDbEntity* pEnt2=NULL;
    int rc1 = acedEntSel("\n  :", en1, pn1);

    if (rc1 != RTNORM) {
        acutPrintf("\n  .\n", rc1);
        return Acad::eUserBreak;
    }
	acdbGetObjectId(eId1, en1);
	highlightAll(eId1);
	acdbOpenObject(pEnt1, eId1, AcDb::kForWrite);
	    if (!pEnt1->isKindOf(AcDbLine::desc()))
    {
        acutPrintf("\n  ");
            pEnt1->close();
			unhighlightAll(eId1);
            return Acad::eUserBreak;
    }

    int rc2 = acedEntSel("\n  :", en2, pn2);

    if (rc2 != RTNORM ) {
        acutPrintf("\n  .\n", rc2);
		pEnt1->close();
		unhighlightAll(eId1);
		
        return Acad::eUserBreak;
    }
    acdbGetObjectId(eId2, en2);
	
			if (eId1.handle() == eId2.handle()) {
			pEnt1->close();
			

			unhighlightAll(eId1);
			acutPrintf("\n");
			return Acad::eInvalidInput;}
			highlightAll(eId2);
			acdbOpenObject(pEnt2, eId2, AcDb::kForWrite);
	
	    if (!pEnt2->isKindOf(AcDbLine::desc()))
    {
        acutPrintf("\n  ");
			pEnt1->close();
			pEnt2->close();
			unhighlightAll(eId1);
			unhighlightAll(eId2);
			return Acad::eUserBreak;
    }

//     AcDLine    AcDbEntity*
AcDbLine* pLine1 = AcDbLine::cast(pEnt1);
sp1 = pLine1->startPoint();
ep1 = pLine1->endPoint();   
AcDbLine* pLine2 = AcDbLine::cast(pEnt2);
sp2 = pLine2->startPoint();
ep2 = pLine2->endPoint(); 
AcGePoint3d gePt;
ads_point adsPt;
adsPt[0] =(pn1[0] + pn2[0]) / 2.0;
adsPt[1] =(pn1[1] + pn2[1]) / 2.0;
adsPt[2] =(pn1[2] + pn2[2]) / 2.0;
gePt=AcGePoint3d(adsPt[0],adsPt[1],adsPt[2]);
	;
double dist1,dist2,dist3,dist4;
dist1=gePt.distanceTo(sp1);
dist2=gePt.distanceTo(ep1);
dist3=gePt.distanceTo(sp2);
dist4=gePt.distanceTo(ep2);

if (dist1 < dist2){
	nsp=ep1;}
	else
	{nsp = sp1;}
if (dist3 < dist4){
	nep=ep2;}
	else
	{nep = sp2;}


	AcDbLine* pLine = new AcDbLine(nsp, nep);
	if (!pLine)
	{
		acedAlert("  ,   !");
		return Acad::eOutOfMemory;
	}
	
	AcDbObjectId id;
	postToDatabase(pLine, id);        
	changeColor(id,pEnt1->colorIndex());
	setTypeLine(id,pEnt1->linetype());

	pEnt1->erase();
    pEnt1->close();
	pEnt2->erase();
    pEnt2->close();

return Acad::eOk;  

}

/******************************************************************
**  double Normal()
**  
**	  
**
**  **avb
**
****************************/

double Normal()
{
ads_real res;
acedInitGet(5,"");
acedGetAngle(NULL,"\n :",&res);
setDblSysVar("SNAPANG", res);
return res;
}
/******************************************************************
**  void countline()
**  
**	     
**
**  **avb
**
****************************/
void
countline()
{
	AcDbObjectId eId;
	double distall=0;
	ads_name sset;
	int gclr, sclr;
	sclr=set_ColorIndex("\n  / <ENTER>- ");
	if (sclr==500)
		return;
    if (acedSSGet(NULL, NULL, NULL, NULL, sset) != RTNORM) {
		acutPrintf(" \n  " );
        return;
    }
    long length;
    acedSSLength(sset, &length);
    AcDbObjectIdArray  objList;
    AcDbObjectId ownerId = AcDbObjectId::kNull;
    for (int i = 0; i < length; i++) {
        ads_name en;
        acedSSName(sset, i, en);
        acdbGetObjectId(eId, en);
	
	double dist;
	AcDbObject *pObj;
	AcDbEntity* pEnt;
    acdbOpenObject(pObj, eId, AcDb::kForRead);
	pObj->close();
	gclr=get_ColorIndex(eId);
	if (sclr==300)
		gclr = sclr;
	else if (gclr==256) {
		acdbOpenObject(pEnt, eId, AcDb::kForRead);
		char* nameLayer=pEnt->layer();
		pEnt->close();
		gclr=getLayerColor(nameLayer);
	}
	
		if (pObj->isKindOf(AcDb2dPolyline::desc()) &&  (gclr == sclr)){
			dist=iterate(eId);
		distall = distall + dist	;
		} else if (pObj->isKindOf(AcDbPolyline::desc()) &&  (gclr == sclr )) {
			dist=plineLength(eId);
			distall = distall + dist	;
		} else if (pObj->isKindOf(AcDbLine::desc()) &&  (gclr == sclr )) {
			dist=lenLine(eId);
			distall = distall + dist	;
		} 
	
	}
	
		acedSSFree(sset);	

acutPrintf(" \n  = %f\n",  distall );
		

}

/******************************************************************
**  void pEdit()
**  
**	    
**
**  **avb
**
****************************/
void pEdit()
{
	AcDbObjectId eId;
	AcDbObject *pObj;
	ads_name sset;
	ads_real realVal;
	AcGePoint3d sp;
	AcGePoint3d ep;
    if (acedSSGet(NULL, NULL, NULL, NULL, sset) != RTNORM) {
		acutPrintf(" \n  " );
        return;
    }
	if	(acedGetReal("\n :", &realVal)!= RTNORM) {
		      acutPrintf("\n  ");
	return;}

    long length;
    acedSSLength(sset, &length);
    AcDbObjectIdArray  objList;
    AcDbObjectId ownerId = AcDbObjectId::kNull;
    for (int i = 0; i < length; i++) {
        ads_name en;
        acedSSName(sset, i, en);
        acdbGetObjectId(eId, en);
		acdbOpenObject(pObj, eId, AcDb::kForRead);
		pObj->close();
		if (pObj->isKindOf(AcDb2dPolyline::desc())){
			pObj->close();
			AcDb2dPolyline* p2dPLine = AcDb2dPolyline::cast(pObj);
			pline2dWidth(p2dPLine, realVal);	}
		else if (pObj->isKindOf(AcDb3dPolyline::desc()))  {
			pObj->close();
			AcDb3dPolyline* p3dPLine = AcDb3dPolyline::cast(pObj);
			//pline3dWidth(p3dPLine, realVal);	}
		}
		else if (pObj->isKindOf(AcDbPolyline::desc()))  {
			pObj->close();
				
			plineWidth(eId, realVal);
		}
		else if (pObj->isKindOf(AcDbLine::desc())) {
				acdbOpenObject(pObj, eId, AcDb::kForWrite);
				pObj->erase();		
				pObj->close();
				AcDbLine* pLine = AcDbLine::cast(pObj);
				sp = pLine->startPoint();
				ep = pLine->endPoint();
		
		create2Polyline(sp,ep,realVal,pLine->colorIndex(),pLine->linetype());}
	}


    return ; 
}
/******************************************************************
**  void ten()
**  
**	 
**
**  **avb
**
****************************/
void ten()
{
ads_name ent; 
ads_point pt;
struct resbuf *entdata; 
acedEntSel("\n ", ent, pt);
entdata = acdbEntGet(ent); 
    if (entdata == NULL) { 
        acdbFail("  \n"); 
        return ; 
    } 
	    if (acedUsrBrk() == TRUE) { 
        acdbFail(" \n"); 
		acutRelRb(entdata);
        return ;     } 
		printList(entdata);
acutRelRb(entdata);
	return;
}
/******************************************************************
**  void entitiesNested()
**  
**	 
**
**  **avb
**
****************************/
void entitiesNested()
{

	AcDbObjectIdArray objIds;
	AcDbObjectId objId;
	ads_point ptResult;
	ads_name ent;
	ads_matrix xformres;
	struct resbuf *refstkres, *entdata;

	refstkres = NULL;
	int	result = acedNEntSelP("\n ", ent, ptResult, 0, xformres, &refstkres);
	if (refstkres != NULL){
		acutRelRb(refstkres);}	//       ents .

	if (result == RTNORM) {
		entdata = acdbEntGet(ent); 
				if (entdata == NULL) { 
					acdbFail("  \n"); 
					return ; 
				} 
					if (acedUsrBrk() == TRUE) { 
					acdbFail(" \n"); 
					return ;     } 
					printList(entdata);
			acutRelRb(entdata);
		}
	
			return;
	

}
/******************************************************************
**  void initApp()
**  
**	
**
**  **avb
**
****************************/
void initApp()
{
	//   
acedRegCmds->addCommand("AVBcom","avbCl","vbCl",ACRX_CMD_MODAL,addLineCommand);
	//   
acedRegCmds->addCommand("AVBcom","avbSel","avbSel",ACRX_CMD_MODAL,selEntity);
	//   
acedRegCmds->addCommand("AVBcom","avbLp","vbLp",ACRX_CMD_MODAL,crLpLine);
	//  
acedRegCmds->addCommand("AVBcom","avbJl","vbJl",ACRX_CMD_MODAL,jLine);
	// 
acedRegCmds->addCommand("AVBcom","avbNor","avbNor",ACRX_CMD_MODAL,mNormal);
	//  
acedRegCmds->addCommand("AVBcom","avbPl","avbPl",ACRX_CMD_MODAL,countline);
	// 
acedRegCmds->addCommand("AVBcom","avbPe","avbPe",ACRX_CMD_MODAL,pEdit);
	// 
acedRegCmds->addCommand("AVBcom","avbEn","En",ACRX_CMD_MODAL,ten);
	// 
acedRegCmds->addCommand("AVBcom","avbnEn","nEn",ACRX_CMD_MODAL,entitiesNested);
	//
//acedRegCmds->addCommand("AVB","avbSt","avbSt",ACRX_CMD_MODAL,changeText);
	
}

/******************************************************************
**  void unloadApp()
**  
**	 
**
**  **avb
**
****************************/
void unloadApp()
{
    acedRegCmds->removeGroup("AVBcom");
}
/******************************************************************
**  void addLineCommand()
**  void crLpLine()
**	void selEntity()
**	void sLine()
**	void jLine()
**	void mNormal()
**
**	,   
**
**  **avb
**
****************************/
/////////////////////////////////////
void addLineCommand()
{
	//   
	ColorLine();
}
/////////////////////////////////////
void crLpLine()
{
	//   
	createLpLine();
}
/////////////////////////////////////
void selEntity()
{
	//  
changeColorEntity();
}
/////////////////////////////////////

void jLine()
{
	//  
join();
}
void mNormal()
{
Normal();
}
/******************************************************************
**  extern "C" AcRx::AppRetCode
**	acrxEntryPoint(AcRx::AppMsgCode msg, void* pkt)
**  
**	   AutoCad
**
**  **avb
**
****************************/
extern "C" AcRx::AppRetCode 
acrxEntryPoint(AcRx::AppMsgCode msg, void* pkt)
{
    switch (msg) 
	    {
		case AcRx::kInitAppMsg:
			acrxDynamicLinker->unlockApplication(pkt);
			acrxRegisterAppMDIAware(pkt);
			initApp();
			break;
		case AcRx::kUnloadAppMsg:
			unloadApp();
			break;
    }
    return AcRx::kRetOK;
}
/////////////////////////////////////
